Attribute VB_Name = "wheel_90_routines"

Sub NatalCaptions_90()
    ReDim Wheels1Captions_90$(7)

    Wheels1Captions_90$(1) = ZN$ & " - natal"
    Wheels1Captions_90$(2) = Format$(NatalDate$, "dd mmm yyyy")
    Wheels1Captions_90$(3) = Format$(NatalTime!, "#0.00") & " " & AMorPM$ & " (" & NatalTimeZone! & ")"
    Wheels1Captions_90$(4) = Format$(Abs(NatalLong!), "##0.00") & " " & NatalD1$
    Wheels1Captions_90$(5) = Format$(Abs(NatalLat!), "#0.00") & " " & NatalD2$
    Wheels1Captions_90$(6) = NatalST

    ReDim Wheels2Captions_90$(7)
End Sub


Public Sub Setup90DegreeHouses()
    HC(1) = 0: HC(2) = 7.5: HC(3) = 15
    HC(4) = 22.5: HC(5) = 30: HC(6) = 37.5

    HC(7) = 45: HC(8) = 52.5: HC(9) = 60
    HC(10) = 67.5: HC(11) = 75: HC(12) = 82.5
End Sub




Public Sub Draw_single_90_natal_wheel()
    Dim X%

    Call NatalCaptions_90

    WheelType_90% = 1
    Wheels1Captions_90$(1) = ZN$ & " - 90 degree wheel"
    Wheels1Captions_90$(7) = ""

    Call Setup90DegreeHouses

    For X% = 1 To num_pl_bodies_90%
        Planets(X%) = Natal_90(X%)
S90X:
        If Planets(X%) >= 90 Then
            Planets(X%) = Planets(X%) - 90
            GoTo S90X
        End If
    Next X%

    Retrograde_90$ = NatalH_90$

    ax1$ = NatalDate$: SiderealTime$ = NatalST$

    Call Planets_in_houses_90: OuterPH_90$ = ph$

    LO = NatalLong!: LA = NatalLat!: d1$ = NatalD1$: d2$ = NatalD2$
    InnerOuter_90% = 1: NatORSyn_90% = 0: XSTEP% = 0

    If InputD1!chk2ndPerson.Value = 0 Then
        NatOrTranOuter_90% = 0
    End If

    Unload wheels_90: wheels_90.Show
End Sub

Public Sub Draw_dual_90_natal_transit_wheel()
    Dim X%

    NatOrTranOuter_90% = 0
    ReDim Wheels1Captions_90$(7), Wheels2Captions_90$(7)

    Wheels1Captions_90$(1) = ZN$ & " - 90 degree wheel"
    Wheels1Captions_90$(2) = Format$(NatalDate$, "dd mmm yyyy")
    Wheels1Captions_90$(3) = Format$(NatalTime!, "#0.00") & " " & AMorPM$ & " (" & NatalTimeZone! & ")"
    Wheels1Captions_90$(4) = Format$(Abs(NatalLong!), "##0.00") & " " & NatalD1$
    Wheels1Captions_90$(5) = Format$(Abs(NatalLat!), "#0.00") & " " & NatalD2$
    Wheels1Captions_90$(6) = NatalST
    Wheels1Captions_90$(7) = ""

    Wheels2Captions_90$(2) = Format$(DiurnalDate$, "dd mmm yyyy")
    Wheels2Captions_90$(3) = Format$(DiurnalTime!, "#0.00") & " " & DiurnalBirthTime$ & " (" & DiurnalTimeZone! & ")"
    Wheels2Captions_90$(4) = Format$(Abs(DiurnalLong!), "##0.00") & " " & DiurnalD1$
    Wheels2Captions_90$(5) = Format$(Abs(DiurnalLat!), "#0.00") & " " & DiurnalD2$

    If InputD1!chk2ndPerson.Value = 1 Then
        Wheels2Captions_90$(1) = InputD1!chk2ndPerson.Caption
        Wheels2Captions_90$(6) = TransitST
        Wheels2Captions_90$(7) = "Inner - natal"
    Else
        Wheels2Captions_90$(1) = "Diurnal data"
        Wheels2Captions_90$(6) = "Inner = transits"
        Wheels2Captions_90$(7) = ""
    End If

    Call Setup90DegreeHouses

    For X% = 1 To num_pl_bodies_90%
        Planets(X%) = Natal_90(X%)
S90Xa:
        If Planets(X%) >= 90 Then
            Planets(X%) = Planets(X%) - 90
            GoTo S90Xa
        End If
    Next X%

    Retrograde_90$ = NatalH_90$

    ax1$ = NatalDate$: SiderealTime$ = NatalST$

    Call Planets_in_houses_90: OuterPH_90$ = ph$

    LO = NatalLong!: LA = NatalLat!: d1$ = NatalD1$: d2$ = NatalD2$

    For X% = 1 To num_pl_bodies_90%
        p1(X%) = Transit_90(X%)
S90Xc:
        If p1(X%) >= 90 Then
            p1(X%) = p1(X%) - 90
            GoTo S90Xc
        End If
    Next X%

    h1_90$ = TransitH_90$

    XSTEP% = 0: InnerOuter_90% = 1
    NatORSyn_90% = 1: WheelType_90% = 2

    Unload wheels_90: wheels_90.Show
End Sub

Public Sub Get_Planet_Positions_90()
    Dim t$, x1b%

    ReDim Natal_90(num_pl_bodies_90%)
    ReDim Transit_90(num_pl_bodies_90%)
    ReDim Planets(num_pl_bodies_90%)
    ReDim p1(num_pl_bodies_90%)
    ReDim p2(num_pl_bodies_90%)

    ReDim CWPlanets_90(num_pl_bodies_90% * 2), CWPlanetAngle_90(num_pl_bodies_90% * 2)
    ReDim HOME(num_pl_bodies_90% * 2), CWIndexy(num_pl_bodies_90% * 2)
    ReDim SORT(num_pl_bodies_90%), SORTPOS(num_pl_bodies_90%)

    ReDim glyph_num%(num_pl_bodies_90%)

'assign glyphs - standard planets
    Unload display_symbols
    planet_symbol_table$ = ""

    For x1b% = 1 To 27
        glyph_num%(x1b%) = 223 + x1b%
        t$ = Mid$(pl_body_name_90$(x1b%), InStr(pl_body_name_90$(x1b%), " ") + 1)
        planet_symbol_table$ = planet_symbol_table$ & Chr$(glyph_num%(x1b%)) & " - " & t$ & crlf
    Next x1b%

    planet_symbol_table$ = planet_symbol_table$ & crlf

'assign glyphs - asteroids
    For x1b% = 28 To num_pl_bodies_90%
        glyph_num%(x1b%) = 69 + x1b%        'start with 'a' and go up (28 + 69 = 97 = '01')
        t$ = Mid$(pl_body_name_90$(x1b%), InStr(pl_body_name_90$(x1b%), " ") + 1)
        planet_symbol_table$ = planet_symbol_table$ & Format$(x1b% - 27, "00") & " - " & t$ & crlf
    Next x1b%

'do natal calculations
    iday% = NatalDay%
    imonth% = NatalMonth%
    iyear% = NatalYear%

    ihour! = Val(InputD!txtBirthHour.Text)
    If InputD!optAM.Value = True Then
        If Fix(ihour!) = 12 Then ihour! = ihour! - 12
    Else
        If Fix(ihour!) <> 12 Then ihour! = ihour! + 12
    End If

    ihour! = ihour! + NatalTimeZone!
    imin! = Val(InputD!txtBirthMinute.Text)

    Call PlanetEquations_90

    For x1b% = 1 To num_pl_bodies_90%
        Natal_90(x1b%) = Planets(x1b%)
    Next x1b%

    NatalH_90$ = Retrograde_90$

'do transit calculations
    iday% = DiurnalDay%
    imonth% = DiurnalMonth%
    iyear% = DiurnalYear%

    ihour! = Val(InputD1!txtDiurnalHour.Text)
    If InputD1!optDiurnalAM.Value = True Then
        If Fix(ihour!) = 12 Then ihour! = ihour! - 12
    Else
        If Fix(ihour!) <> 12 Then ihour! = ihour! + 12
    End If

    ihour! = ihour! + DiurnalTimeZone!
    imin! = Val(InputD1!txtDiurnalMinute.Text)

    Call PlanetEquations_90

    For x1b% = 1 To num_pl_bodies_90%
        Transit_90(x1b%) = Planets(x1b%)
    Next x1b%

    TransitH_90$ = Retrograde_90$
    h1_90$ = TransitH_90$
End Sub

Public Sub PlanetEquations_90()
    Dim pl_num%, Y%
    Dim cal As Byte, H, X(6) As Double

    ReDim SpeedX(num_pl_bodies_90%)

    H = ihour! + imin! / 60#

 ' the next two functions do the same job, converting a calendar date into a Julian day number
 ' swe_date_conversion() checks for legal dates while swe_julday() handles even illegal things like 45 Januar etc.
    cal = 103  ' g for gregorian calendar

    tjd_ut = swe_julday(iyear%, imonth%, iday%, H, 1)
    retval = swe_date_conversion(iyear, imonth, iday, H, cal, tjd_ut)

    'tjd_et = tjd_ut
    tjd_et = tjd_ut + swe_deltat(tjd_ut)            '08 May 2006

    For Y% = 1 To num_pl_bodies_90%
        iflag = 258                     'for geo

        serr$ = String(255, 0)
        plnam$ = String(20, 0)

        pl_num% = Val(Left$(pl_body_name_90$(Y%), InStr(pl_body_name_90$(Y%), " ")))
        ret_flag = swe_calc(tjd_et, pl_num%, iflag, X(0), serr$)

        Planets(Y%) = X(0)
        SpeedX(Y%) = X(3)
    Next Y%

    swe_close

    Retrograde_90$ = Space$(num_pl_bodies_90%)

    For Y% = 1 To num_pl_bodies_90%
        If SpeedX(Y%) < 0 Then
            Mid$(Retrograde_90$, Y%, 1) = "R"
        End If
    Next Y%
End Sub

Public Sub Planets_in_houses_90()
    Dim temp, X, Y

    ph$ = Space(num_pl_bodies_90% * 10)

    For X = 1 To 12
        For Y = 1 To num_pl_bodies_90%
            Mid$(ph$, Y * 10 - 5, 10) = " HOUSE"
            temp = Planets(Y) + (1 / 36000)

            If X < 12 And HC(X) > HC(X + 1) Then
                If (temp >= HC(X) And temp < 360) Or (temp < HC(X + 1) And temp >= 0) Then
                    Mid$(ph$, Y * 10 - 9, Y * 10 - 6) = Mid$(HCX1$, X * 4 - 3, 4)
                End If
                GoTo PIH9
            End If

            If X = 12 And HC(X) > HC(1) Then
                If (temp >= HC(X) And temp < 360) Or (temp < HC(1) And temp >= 0) Then
                    Mid$(ph$, Y * 10 - 9, Y * 10 - 6) = Mid$(HCX1$, X * 4 - 3, 4)
                End If
                GoTo PIH9
            End If

            If temp >= HC(X) And temp < HC(X + 1) And X < 12 Then
                Mid$(ph$, Y * 10 - 9, 4) = Mid$(HCX1$, X * 4 - 3, 4)
                GoTo PIH9
            End If

            If temp >= HC(X) And temp < HC(1) And X = 12 Then
                Mid$(ph$, Y * 10 - 9, 4) = Mid$(HCX1$, X * 4 - 3, 4)
            End If
PIH9:
        Next Y
    Next X
End Sub
